#!/usr/bin/env python3
# -*- coding: UTF-8 -*-
#version=[2022.12.07]

import regex as re

usernameBlackWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|\\b[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*\\b|\\b[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*\\b|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:։|᛬|˸|꞉|︰|:|ः|᠃|ઃ|ꓽ|ː|׃|：|⁚|܄|∶|܃|᠉)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝟺|Ꮞ|𝟜|4|𝟰|ꮞ|𑣏|🯴|𑢯|𝟦|𝟒)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝟺|Ꮞ|𝟜|4|𝟰|ꮞ|𑣏|🯴|𑢯|𝟦|𝟒)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔞|𝙰|ᴀ|ă|𝖺|Ǟ|Â|𝚨|Ȁ|Ậ|𝚊|ǟ|ꓮ|𐊠|Ẳ|𝒜|Å|𝖆|ᵃ|@|Ȃ|ȁ|а|Ẵ|𝛢|𝛼|𝑨|𝖠|𝝖|ᗅ|Ａ|𝜶|ạ|Ā|Ȧ|𝘈|ậ|ɑ|𝙖|𝘼|Ǡ|Ẩ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|á|𝘢|Ɑ|ǻ|𝞐|Ã|a|ḁ|Ặ|𝐚|𝝰|å|𝑎|ȃ|Ẫ|ȧ|𝓐|ǎ|𝜜|ẚ|𝒂|À|ặ|Ǎ|Ǻ|ẫ|𝐴|Ḁ|ấ|A|𝓪|⍺|ā|𝗔|ả|𝕒|𝗮|Α|ä|Ắ|α|𝞪|ã|Ą|𝒶|à|Ấ|Ă|Á|𝛂|ǡ|𝕬|Ằ|ắ|ằ|𖽀|Ä|Å|ẩ|Ạ|Ả|А|ẵ|ầ|ẳ|ą|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:꘎|․|\.|܁|𐩐|۰|𝅭|٠|܂|ꓸ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:٭|⁎|\*|𐌟|∗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:٭|⁎|\*|𐌟|∗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔞|𝙰|ᴀ|ă|𝖺|Ǟ|Â|𝚨|Ȁ|Ậ|𝚊|ǟ|ꓮ|𐊠|Ẳ|𝒜|Å|𝖆|ᵃ|@|Ȃ|ȁ|а|Ẵ|𝛢|𝛼|𝑨|𝖠|𝝖|ᗅ|Ａ|𝜶|ạ|Ā|Ȧ|𝘈|ậ|ɑ|𝙖|𝘼|Ǡ|Ẩ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|á|𝘢|Ɑ|ǻ|𝞐|Ã|a|ḁ|Ặ|𝐚|𝝰|å|𝑎|ȃ|Ẫ|ȧ|𝓐|ǎ|𝜜|ẚ|𝒂|À|ặ|Ǎ|Ǻ|ẫ|𝐴|Ḁ|ấ|A|𝓪|⍺|ā|𝗔|ả|𝕒|𝗮|Α|ä|Ắ|α|𝞪|ã|Ą|𝒶|à|Ấ|Ă|Á|𝛂|ǡ|𝕬|Ằ|ắ|ằ|𖽀|Ä|Å|ẩ|Ạ|Ả|А|ẵ|ầ|ẳ|ą|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:卐|࿕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:卍|࿖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŵ|Ѡ|Ẇ|𝖜|W|Ẁ|𝕎|𝚆|Ẃ|ꓪ|𑣯|𑜏|Ɯ|𝔚|𝔀|ẉ|w|ԝ|𝐖|𝕨|Ẅ|Ԝ|𝙒|ẇ|ѡ|ẅ|𝙬|Ա|ᴡ|𝑾|𝑤|𝗪|ẁ|ꮤ|ɯ|𝗐|ŵ|𝖶|𝖂|ẃ|𝒲|𑜊|Ꮤ|𑣦|ꮃ|𝚠|𝔴|𝓌|Ẉ|𝘄|Ꮃ|𝓦|ẘ|𝘸|𝑊|ա|𝐰|𑜎|𝒘|𝘞)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ẍ|Χ|⤬|𝙭|ꭓ|𝔁|𝓍|х|᙭|ꓫ|Ⲭ|𐔧|𑣬|ⅹ|𝝬|×|Ｘ|ᚷ|𝛸|ⵝ|𝟀|⤫|ｘ|𝓧|𝝌|𝗑|𝕩|𝞆|𝑋|𝚇|𐌢|𝖝|𝗫|𝙓|ẋ|ᕁ|ⲭ|𝐗|𐊴|Ẍ|Х|𐌗|ꭕ|𝚾|𝐱|𝘅|𝒳|𝒙|Ꭓ|𐊐|⨯|𝚡|𝑥|᙮|𝑿|𝔵|𝜲|𝖃|𝜒|𝖷|ᕽ|𝕏|X|𝛘|χ|╳|𝘟|x|𝞦|Ẋ|𝔛|Ⅹ|𝘹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

usernameNovidBlackWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŵ|Ѡ|Ẇ|𝖜|W|Ẁ|𝕎|𝚆|Ẃ|ꓪ|𑣯|𑜏|Ɯ|𝔚|𝔀|ẉ|w|ԝ|𝐖|𝕨|Ẅ|Ԝ|𝙒|ẇ|ѡ|ẅ|𝙬|Ա|ᴡ|𝑾|𝑤|𝗪|ẁ|ꮤ|ɯ|𝗐|ŵ|𝖶|𝖂|ẃ|𝒲|𑜊|Ꮤ|𑣦|ꮃ|𝚠|𝔴|𝓌|Ẉ|𝘄|Ꮃ|𝓦|ẘ|𝘸|𝑊|ա|𝐰|𑜎|𝒘|𝘞)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|ǒ|𝙊|𝛰|ỏ|𝞼|Ṓ|𝚘|૦|ȏ|ồ|𝙾|Ǭ|𝞂|ő|ﮬ|Ọ|ﻫ|𝟢|ଠ|ං|ﮦ|Ờ|õ|ဝ|ዐ|𐊒|𞹤|𝟶|𝑜|Õ|𝑶|ộ|𑣗|ｏ|𝐨|ȱ|ℴ|0|𐊫|Ơ|𝓸|Ǫ|〇|ổ|𑣕|໐|ﻪ|Ṑ|߀|ﮧ|Ȭ|Օ|ṍ|ỗ|০|Ő|๐|σ|🯰|൦|о|𝛐|ھ|Ｏ|𐐬|Ȏ|၀|ہ|𐓪|ﮪ|𝔬|𑓐|Ổ|𝔒|ﮫ|Ṍ|ớ|ഠ|𝟘|𝖔|𝒐|੦|ȫ|Ǒ|Ò|Ỡ|Ó|ǫ|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|ⲟ|𝗼|೦|𝘰|𑣈|ﮩ|Ȯ|𑢵|Ö|𝝈|ο|𝙤|ȍ|ố|ȭ|𝕠|ŏ|ơ|𝓞|O|ಂ|𝕆|𝜎|𝕺|ỡ|О|ö|ᴏ|Ȱ|𝞸|𝜪|o|ം|𞸤|௦|ṏ|𝗈|Ō|𝞞|Ṏ|ò|ه|ꓳ|𝝤|O'|ﮭ|୦|𝘖|Ⲟ|ⵔ|ở|𝜊|ô|Ợ|Ỗ|Ŏ|𝖮|ō|Ȍ|Ȫ|ó|Ớ|𐓂|ﻬ|Ộ|𝝾|ợ|ꬽ|𝟎|𐔖|𝝄|𐐄|ס|ṑ|ȯ|𝗢|Ο|𞺄|𝑂|𝟬|ᴑ|ە|Ở|Ỏ|ం|۵|𝒪|օ|ọ|ǭ|ờ|𝛔|٥|ﻩ|𑣠|Ồ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŵ|Ѡ|Ẇ|𝖜|W|Ẁ|𝕎|𝚆|Ẃ|ꓪ|𑣯|𑜏|Ɯ|𝔚|𝔀|ẉ|w|ԝ|𝐖|𝕨|Ẅ|Ԝ|𝙒|ẇ|ѡ|ẅ|𝙬|Ա|ᴡ|𝑾|𝑤|𝗪|ẁ|ꮤ|ɯ|𝗐|ŵ|𝖶|𝖂|ẃ|𝒲|𑜊|Ꮤ|𑣦|ꮃ|𝚠|𝔴|𝓌|Ẉ|𝘄|Ꮃ|𝓦|ẘ|𝘸|𝑊|ա|𝐰|𑜎|𝒘|𝘞)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŵ|Ѡ|Ẇ|𝖜|W|Ẁ|𝕎|𝚆|Ẃ|ꓪ|𑣯|𑜏|Ɯ|𝔚|𝔀|ẉ|w|ԝ|𝐖|𝕨|Ẅ|Ԝ|𝙒|ẇ|ѡ|ẅ|𝙬|Ա|ᴡ|𝑾|𝑤|𝗪|ẁ|ꮤ|ɯ|𝗐|ŵ|𝖶|𝖂|ẃ|𝒲|𑜊|Ꮤ|𑣦|ꮃ|𝚠|𝔴|𝓌|Ẉ|𝘄|Ꮃ|𝓦|ẘ|𝘸|𝑊|ա|𝐰|𑜎|𝒘|𝘞)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

blackAdWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

redAdWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ẍ|Χ|⤬|𝙭|ꭓ|𝔁|𝓍|х|᙭|ꓫ|Ⲭ|𐔧|𑣬|ⅹ|𝝬|×|Ｘ|ᚷ|𝛸|ⵝ|𝟀|⤫|ｘ|𝓧|𝝌|𝗑|𝕩|𝞆|𝑋|𝚇|𐌢|𝖝|𝗫|𝙓|ẋ|ᕁ|ⲭ|𝐗|𐊴|Ẍ|Х|𐌗|ꭕ|𝚾|𝐱|𝘅|𝒳|𝒙|Ꭓ|𐊐|⨯|𝚡|𝑥|᙮|𝑿|𝔵|𝜲|𝖃|𝜒|𝖷|ᕽ|𝕏|X|𝛘|χ|╳|𝘟|x|𝞦|Ẋ|𝔛|Ⅹ|𝘹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|𐌠|Ⅰ|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|ͺ|𝟙|і|î|𝙸|𝐥|ן|ǃ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝗶|ˡ|𝙄|Ɩ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|ɪ|Ｉ|Í|𝒾|𝖨|ḷ|ḻ|Ḭ|𞸀|׀|𝘐|𝛪|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|Ï|𝗅|𝐢|L|𞺀|𐊊|!|𝗂|ḯ|𝕝|𝜾|ﺍ|𝑙|\||𝖎|ｉ|1|i|∣|𝟏|Ĭ|Ị|ℓ|ï|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|ᛁ|𑢣|𝝸|ɩ|𝗹|ℐ|𝟷|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|𝚒|𝒊|ĩ|İ|Į|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:٭|⁎|\*|𐌟|∗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:٭|⁎|\*|𐌟|∗)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ẍ|Χ|⤬|𝙭|ꭓ|𝔁|𝓍|х|᙭|ꓫ|Ⲭ|𐔧|𑣬|ⅹ|𝝬|×|Ｘ|ᚷ|𝛸|ⵝ|𝟀|⤫|ｘ|𝓧|𝝌|𝗑|𝕩|𝞆|𝑋|𝚇|𐌢|𝖝|𝗫|𝙓|ẋ|ᕁ|ⲭ|𝐗|𐊴|Ẍ|Х|𐌗|ꭕ|𝚾|𝐱|𝘅|𝒳|𝒙|Ꭓ|𐊐|⨯|𝚡|𝑥|᙮|𝑿|𝔵|𝜲|𝖃|𝜒|𝖷|ᕽ|𝕏|X|𝛘|χ|╳|𝘟|x|𝞦|Ẋ|𝔛|Ⅹ|𝘹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|Ĺ|Ī|ｌ|ļ|Ì|𝒍|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|ͅ|𐊊|!|𐔦|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𐌚|৪|੪|𞣋|𝟾|𝟠|𝟪|🯸|𝟖|ଃ|Ȣ|ȣ|8|𝟴)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:᛭|➕|\+|𐊛)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

yellowAdWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝔞|𝙰|ᴀ|ă|Ǟ|𝖺|Â|𝚨|Ȁ|Ậ|𝚊|ꓮ|𐊠|ǟ|Ẳ|𝒜|Å|𝖆|ᵃ|Ȃ|@|ȁ|Ẵ|а|𝛢|𝛼|𝑨|𝖠|𝝖|ᗅ|Ａ|𝜶|ạ|Ā|Ȧ|𝘈|ậ|ɑ|𝙖|𝘼|Ǡ|Ẩ|Ầ|â|Ꭺ|𝔸|ａ|𝐀|á|𝘢|ǻ|𝞐|Ã|a|ḁ|𝐚|𝝰|Ặ|å|𝑎|ȃ|Ẫ|𝓐|ȧ|ǎ|𝜜|𝒂|À|ặ|Ǎ|Ǻ|𝐴|ẫ|Ḁ|ấ|ꭺ|A|𝓪|⍺|ā|ą|𝗔|ả|𝕒|𝗮|Α|ä|Ắ|α|𝞪|ã|Ą|𝒶|à|Ấ|Ă|Á|𝛂|ǡ|𝕬|Ằ|ằ|Ä|𖽀|ẩ|Å|Ạ|Ả|А|ẵ|ầ|ẳ|ắ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

usernameRedWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŵ|Ѡ|Ẇ|𝖜|W|Ẁ|𝕎|𝚆|Ẃ|ꓪ|𑣯|𑜏|Ɯ|𝔚|𝔀|ẉ|w|ԝ|𝐖|𝕨|Ẅ|Ԝ|𝙒|ẇ|ѡ|ẅ|𝙬|Ա|ᴡ|𝑾|𝑤|𝗪|ẁ|ꮤ|ɯ|𝗐|ŵ|𝖶|𝖂|ẃ|𝒲|𑜊|Ꮤ|𑣦|ꮃ|𝚠|𝔴|𝓌|Ẉ|𝘄|Ꮃ|𝓦|ẘ|𝘸|𝑊|ա|𝐰|𑜎|𝒘|𝘞)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:⸜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:/|㇓|⼃|𝈺|ⳇ|⟋|Ⳇ|⁁|∕|ノ|╱|〳|᜵|⁄|丿|⧸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

textBlackWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

doubledSusWordsCompiled = re.compile("([\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ẍ|Χ|⤬|𝙭|ꭓ|𝔁|𝓍|х|᙭|ꓫ|Ⲭ|𐔧|𑣬|ⅹ|𝝬|×|Ｘ|ᚷ|𝛸|ⵝ|𝟀|⤫|ｘ|𝓧|𝝌|𝗑|𝕩|𝞆|𝑋|𝚇|𐌢|𝖝|𝗫|𝙓|ẋ|ᕁ|ⲭ|𝐗|𐊴|Ẍ|Х|𐌗|ꭕ|𝚾|𝐱|𝘅|𝒳|𝒙|Ꭓ|𐊐|⨯|𝚡|𝑥|᙮|𝑿|𝔵|𝜲|𝖃|𝜒|𝖷|ᕽ|𝕏|X|𝛘|χ|╳|𝘟|x|𝞦|Ẋ|𝔛|Ⅹ|𝘹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŵ|Ѡ|Ẇ|𝖜|W|Ẁ|𝕎|𝚆|Ẃ|ꓪ|𑣯|𑜏|Ɯ|𝔚|𝔀|ẉ|w|ԝ|𝐖|𝕨|Ẅ|Ԝ|𝙒|ẇ|ѡ|ẅ|𝙬|Ա|ᴡ|𝑾|𝑤|𝗪|ẁ|ꮤ|ɯ|𝗐|ŵ|𝖶|𝖂|ẃ|𝒲|𑜊|Ꮤ|𑣦|ꮃ|𝚠|𝔴|𝓌|Ẉ|𝘄|Ꮃ|𝓦|ẘ|𝘸|𝑊|ա|𝐰|𑜎|𝒘|𝘞)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŵ|Ѡ|Ẇ|𝖜|W|Ẁ|𝕎|𝚆|Ẃ|ꓪ|𑣯|𑜏|Ɯ|𝔚|𝔀|ẉ|w|ԝ|𝐖|𝕨|Ẅ|Ԝ|𝙒|ẇ|ѡ|ẅ|𝙬|Ա|ᴡ|𝑾|𝑤|𝗪|ẁ|ꮤ|ɯ|𝗐|ŵ|𝖶|𝖂|ẃ|𝒲|𑜊|Ꮤ|𑣦|ꮃ|𝚠|𝔴|𝓌|Ẉ|𝘄|Ꮃ|𝓦|ẘ|𝘸|𝑊|ա|𝐰|𑜎|𝒘|𝘞)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*|[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŵ|Ѡ|Ẇ|𝖜|W|Ẁ|𝕎|𝚆|Ẃ|ꓪ|𑣯|𑜏|Ɯ|𝔚|𝔀|ẉ|w|ԝ|𝐖|𝕨|Ẅ|Ԝ|𝙒|ẇ|ѡ|ẅ|𝙬|Ա|ᴡ|𝑾|𝑤|𝗪|ẁ|ꮤ|ɯ|𝗐|ŵ|𝖶|𝖂|ẃ|𝒲|𑜊|Ꮤ|𑣦|ꮃ|𝚠|𝔴|𝓌|Ẉ|𝘄|Ꮃ|𝓦|ẘ|𝘸|𝑊|ա|𝐰|𑜎|𝒘|𝘞)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*)")

textObfuBlackWordsCompiledPairs = [(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "lagtmer"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "agber"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖽|𝙙|ꓓ|𝕯|𝑑|ⅾ|𝒹|𝖉|𝘿|𝗱|𝙳|Ḓ|ḏ|ꓒ|Ꮷ|𝐃|d|𝘥|𝘋|𝐝|Ḍ|𝔡|Ď|𝒟|𝒅|𝔻|Ḏ|ꭰ|𝚍|ď|Ⅾ|Ԁ|𝕕|ḓ|ḑ|ᑯ|Ꭰ|Ḋ|ꮷ|ᗪ|𝐷|𝖣|D|ᗞ|ḋ|𝓭|ⅅ|𝗗|ᴅ|𝔇|𝑫|ԁ|ⅆ|Ḑ|ḍ|𝓓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), " dsamoiervy"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), " sntmoiecy"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ỷ|ꭚ|𝝪|𑣜|У|Ȳ|𝒚|ý|Y|Ყ|Ｙ|γ|ŷ|ỷ|Ỵ|Ỹ|ｙ|𝘠|𝒴|𝕪|𝛾|𝞬|ꓬ|ẙ|𝞤|𝚼|𝖄|𝔜|𝔂|ϒ|𑢼|Ẏ|ȳ|𐊲|ỳ|ⲩ|𝝲|ꮍ|z|υ|𝓎|𝚢|ℽ|Ŷ|𝙔|Ý|𝖞|𝑦|ყ|𝐘|𝑌|𝐲|ỵ|𝖸|𖽃|Ⲩ|ү|𝗒|𝘺|ỹ|Γ|𝚈|Υ|Ÿ|𑣄|𑢤|𝒀|Ɣ|y|Ꭹ|𝔶|Ỳ|ỿ|𝜸|ᶌ|u|𝘆|у|ɣ|Ү|ꭹ|𝙮|ÿ|ẏ|Ỿ|𝛶|𝕐|𝓨|𝛄|𝗬|𝜰|Ꮍ|ʏ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŵ|Ѡ|Ẇ|𝖜|W|Ẁ|𝕎|𝚆|Ẃ|ꓪ|𑣯|𑜏|Ɯ|𝔚|𝔀|ẉ|w|ԝ|𝐖|𝕨|Ẅ|Ԝ|𝙒|ẇ|ѡ|ẅ|𝙬|Ա|ᴡ|𝑾|𝑤|𝗪|ẁ|ꮤ|ɯ|𝗐|ŵ|𝖶|𝖂|ẃ|𝒲|𑜊|Ꮤ|𑣦|ꮃ|𝚠|𝔴|𝓌|Ẉ|𝘄|Ꮃ|𝓦|ẘ|𝘸|𝑊|ա|𝐰|𑜎|𝒘|𝘞)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), " santwmoecy"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), " lngubierh"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), " lngtoierh"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝓃|𝘯|𝓝|Ｎ|ņ|𐔓|Ń|𝞜|Ṅ|Ņ|Ṇ|𝐍|𝑁|Ñ|𝚴|𝘕|ǹ|𝗻|𝐧|𝗇|ո|𝓷|ν|𝙉|𝙽|𝝢|ꓠ|𝙣|𝕹|ռ|Ǹ|v|Ṉ|ɲ|Ň|ñ|𝔫|𝒩|𝑛|𝖓|ɴ|ṅ|𝕟|N|ｎ|ṋ|ⲛ|n|𝖭|Ν|𝔑|ṇ|ń|Ո|𝚗|𝜨|𝑵|𝛮|Ṋ|𝒏|ℕ|𝗡|ň|ṉ|Ռ|Ⲛ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), " ntboecr"),]

usernameObfuBlackWordsCompiledPairs = [(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "sukbcv"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), " subkcv"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ẍ|Χ|⤬|𝙭|ꭓ|𝔁|𝓍|х|᙭|ꓫ|Ⲭ|𐔧|𑣬|ⅹ|𝝬|×|Ｘ|ᚷ|𝛸|ⵝ|𝟀|⤫|ｘ|𝓧|𝝌|𝗑|𝕩|𝞆|𝑋|𝚇|𐌢|𝖝|𝗫|𝙓|ẋ|ᕁ|ⲭ|𝐗|𐊴|Ẍ|Х|𐌗|ꭕ|𝚾|𝐱|𝘅|𝒳|𝒙|Ꭓ|𐊐|⨯|𝚡|𝑥|᙮|𝑿|𝔵|𝜲|𝖃|𝜒|𝖷|ᕽ|𝕏|X|𝛘|χ|╳|𝘟|x|𝞦|Ẋ|𝔛|Ⅹ|𝘹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "uobxr"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ｂ|Ꞵ|Ḃ|𝕓|𝖇|Ь|𝑏|ʙ|𝔟|В|в|ь|Ᏼ|ꞵ|𝐵|𝒃|ᏼ|ꓐ|𝘣|𝔹|𝘉|ß|ḇ|𝔅|ḅ|𝘽|β|Ḅ|𝖻|𐌁|𝗯|𝐛|𝖡|𝓫|𝓑|ｂ|ꮟ|𝛣|ᖯ|𝜝|𝑩|Β|𝒷|ḃ|ƅ|𝙗|Ƅ|𝙱|𐊡|ϐ|ᗷ|𝚋|𝚩|𝝗|ᑲ|ℬ|Ḇ|b|B|𝗕|Ꮟ|𝕭|𝐁|𝞑|𐊂)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "suobkcr"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ẍ|Χ|⤬|𝙭|ꭓ|𝔁|𝓍|х|᙭|ꓫ|Ⲭ|𐔧|𑣬|ⅹ|𝝬|×|Ｘ|ᚷ|𝛸|ⵝ|𝟀|⤫|ｘ|𝓧|𝝌|𝗑|𝕩|𝞆|𝑋|𝚇|𐌢|𝖝|𝗫|𝙓|ẋ|ᕁ|ⲭ|𝐗|𐊴|Ẍ|Х|𐌗|ꭕ|𝚾|𝐱|𝘅|𝒳|𝒙|Ꭓ|𐊐|⨯|𝚡|𝑥|᙮|𝑿|𝔵|𝜲|𝖃|𝜒|𝖷|ᕽ|𝕏|X|𝛘|χ|╳|𝘟|x|𝞦|Ẋ|𝔛|Ⅹ|𝘹)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "xse"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŵ|Ѡ|Ẇ|𝖜|W|Ẁ|𝕎|𝚆|Ẃ|ꓪ|𑣯|𑜏|Ɯ|𝔚|𝔀|ẉ|w|ԝ|𝐖|𝕨|Ẅ|Ԝ|𝙒|ẇ|ѡ|ẅ|𝙬|Ա|ᴡ|𝑾|𝑤|𝗪|ẁ|ꮤ|ɯ|𝗐|ŵ|𝖶|𝖂|ẃ|𝒲|𑜊|Ꮤ|𑣦|ꮃ|𝚠|𝔴|𝓌|Ẉ|𝘄|Ꮃ|𝓦|ẘ|𝘸|𝑊|ա|𝐰|𑜎|𝒘|𝘞)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ŝ|𝖋|𝘧|ſ|f|𝓯|ꓢ|𝕗|Ｆ|ș|𝙛|𝑆|ş|Ｓ|𝗳|ẝ|𝚏|𝕊|ṣ|ꬵ|Ѕ|ṥ|ꮥ|𝒻|𝓢|Ꮪ|𝘚|Ś|Ṡ|ŝ|𐐠|𝑓|𝚂|𝗌|𝐒|𝐟|𝗦|𝒮|𝕤|ṡ|𖼺|F|𝔰|ṧ|Ṧ|𝑺|s|𑢡|𝖿|𝑠|ṩ|𝔖|𝕾|S|Ꮥ|𝙨|𝓈|Ṩ|տ|ꜱ|ḟ|ƽ|𝒔|𐑈|ｓ|𝘀|Ṥ|𝖲|ꞙ|Ș|𝒇|Ƽ|𝔣|ք|𝖘|Տ|Ş|𝐬|ѕ|𑣁|ғ|𝘴|𝙎|ꮪ|𝓼|Ṣ|ś|𐊖|š|Š|𝚜)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝞀|Ṗ|ᴘ|𝜚|ᴩ|𝜬|𝐩|𝗽|P|ｐ|ꮲ|𝝔|Р|𝕻|Ρ|𝖕|ℙ|𝞠|ϱ|𝛲|𝟈|𝝆|𝗣|ꓑ|ᑭ|𝗉|Ꮲ|𝓟|ρ|𝒑|Ⲣ|𝓅|𝑝|𝘗|𝘱|Ṕ|𝙿|𝛠|𝙋|𝚸|𝒫|𝕡|𐊕|𝖯|𝙥|𝞺|𝜌|ⲣ|𝚙|𝑷|ṗ|𝓹|𝝦|Ｐ|⍴|ṕ|𝔭|𝐏|𝞎|𝛒|p|р|𝑃|𝔓)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "satwph"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "lagtmer"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:ʜ|𝐻|ḩ|𝚮|𝗵|Ĥ|н|𝙃|Һ|𝓗|ｈ|ẖ|𝐇|𝒉|ȟ|𝘩|Հ|ḣ|h|ꮋ|𝕙|𝛨|n̩|ℍ|ḥ|Ḣ|𝑯|Ȟ|Ḩ|ⲏ|ꮒ|𝕳|𝘏|𝙝|ℌ|Ｈ|Н|𝖍|𝐡|𝙷|𐋏|η|𝗛|𝞖|𝖧|𝒽|𝚑|𝓱|һ|𝗁|ĥ|ℋ|𝝜|Ꮒ|ḫ|Ḧ|ᕼ|հ|Ꮋ|Ⲏ|ꓧ|ℎ|Ḥ|Η|Ḫ|𝔥|𝜢|ḧ|H)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐎|Ố|𝛰|Ṓ|ồ|𝞂|Ọ|ﻫ|ଠ|Ờ|õ|ဝ|Σ|6|𞹤|𝑜|Õ|ộ|𑣗|𝐨|𐊫|Ǫ|𑢷|ổ|໐|߀|ﮧ|Ȭ|Օ|ṍ|০|๐|σ|🯰|𝛐|о|ہ|Ổ|𑓐|𝔒|ớ|ȫ|Ǒ|ة|Ò|Ó|𝚶|౦|ჿ|ﮨ|Ô|०|ṓ|೦|𝘰|𑣈|ﮩ|Ȯ|𝝈|ȍ|ȭ|ŏ|𝓞|ơ|O|𝜎|ᴏ|𝞸|𝜪|o|ം|௦|ṏ|𝗈|𝞞|Ṏ|ò|ꓳ|𝝤|O'|ⵔ|𝜊|Ợ|Ỗ|Ŏ|𝖮|Ȍ|ō|Ớ|ó|Ộ|ợ|ꬽ|𝝄|ṑ|𞺄|ᴑ|Ở|Ỏ|ە|۵|𝒪|օ|ờ|𝛔|𑢨|𑣕|𑣠|ο|Ồ|ǒ|𝙊|ỏ|𝞼|𝚘|૦|ȏ|𝙾|Ǭ|ő|ﮬ|𝟢|o'|ං|ﮦ|ዐ|𐊒|𝟶|𝑶|ｏ|ȱ|ℴ|0|Ơ|𝓸|〇|ﻪ|Ṑ|Ჿ|ỗ|Ő|൦|ھ|Ｏ|𐐬|Ȏ|၀|𐓪|ﮪ|𝔬|ﮫ|Ṍ|ഠ|𝟘|𝖔|𝒐|੦|Ỡ|ǫ|ⲟ|𝗼|𑢵|Ö|Ꭴ|𝙤|ố|𝕠|ಂ|𝕆|𝕺|ỡ|О|ö|Ȱ|𞸤|Ō|ه|ﮭ|୦|Ⲟ|ở|ô|Ȫ|𐓂|ﻬ|𝝾|𝟎|𐔖|𐐄|ס|ȯ|𝗢|Ο|𝑂|𝟬|ం|ọ|ǭ|٥|ﻩ|𝘖)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚃|ẗ|ṭ|𝛕|Ͳ|Ｔ|τ|Ţ|𝑻|𑣜|Ṫ|Ṱ|𝓽|𝝉|ｔ|𝜏|𐊱|ꭲ|𝚻|Ṭ|𝚝|ţ|𝞣|𝘵|𐌕|ⲧ|Τ|𝖙|𝔗|Ť|𐊗|𝗧|𝑇|𝝩|𝞽|Ț|𝙏|𝙩|y|𝔱|ț|🝨|T|Ṯ|𝕥|ṯ|𝒕|т|Ꭲ|𝑡|Ⲧ|ᴛ|𝜯|𝖳|⊤|𝗍|𝘛|ť|𑢼|𝓉|𝐭|𝐓|ṱ|𝕿|Т|ͳ|⟙|ṫ|𝓣|t|𖼊|ꓔ|𝕋|𝞃|𝒯|ƫ|𝛵|𝘁)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ḡ|ԍ|Ɠ|ℊ|𝕲|Ğ|𝐺|𝚐|ɠ|𝐆|Ց|𝖌|Ꮐ|𝐠|𝑔|ᏻ|Ĝ|𝖦|𝘎|𝗴|ᶃ|Ᏻ|𝘨|ğ|𝓖|ᵍ|Ｇ|g|𝒈|𝙶|𝔤|𝔊|ĝ|ḡ|ɢ|ꮐ|ᶢ|𝙂|ǧ|Ǧ|𝗀|ģ|𝔾|Ģ|𝗚|𝓰|𝙜|ց|𝑮|G|Ġ|Ǵ|ｇ|g̔|Ɡ|ƍ|ɡ|ꓖ|𝕘|G'|ġ|𝒢|ǵ|Ԍ)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:г|ȓ|𝙍|ᖇ|𝘳|ℛ|ℝ|Ŗ|𝗿|ṙ|Ṛ|Ṟ|ṛ|𝕣|ｒ|ᴦ|Ṝ|Ⲅ|𝖱|ȑ|𝘙|𐓜|ʀ|𝑟|ꓣ|ꮁ|ꭱ|ṟ|ŗ|𖼵|Ꮁ|ř|ꭈ|ⲅ|Г|𝒓|𝓇|ℜ|𝐫|ŕ|𝔯|𝓡|ꮢ|𝚛|𝑹|ʳ|r|Ř|Ｒ|ꭇ|𝚁|Ŕ|𝈖|Ȓ|𝖗|𝑅|ɾ|𝐑|Ṙ|𝗥|𝙧|𐒴|R|𝓻|ᣴ|𝕽|Ȑ|ṝ|Ꮢ|Ʀ|Ꭱ|𝗋)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), " lgtoirh"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝐅|S|ℱ|𝖋|𝘧|f|ſ|𝓯|𝗙|𑢢|𝕗|Ғ|𝔽|𝟊|Ｆ|𝙛|𝈓|𝘍|𝗳|ẝ|ḟ|𝐹|r̵|𝚏|ꬵ|Ꞙ|Γ̵|𑣂|Ք|ｆ|𝒻|ꞙ|𐊥|𝒇|𝔣|ᖴ|𝑓|ք|ꜰ|𝐟|𝟋|Ḟ|𝕱|ғ|F|ϝ|𝑭|𐔥|𝙁|Ϝ|𝔉|𝖥|ꓝ|𝙵|ɍ|𐊇|𝖿|𝓕)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝕦|𝛖|𝝊|ȗ|ꭒ|ṻ|ụ|Ȗ|ų|ṳ|Ṷ|Ǚ|ʋ|ṵ|𝐮|ᑌ|ꭎ|∪|𝕌|ǚ|𐓶|ū|Ǔ|𝑈|𐓎|Ù|𝚞|𝑢|𝜐|û|𝗨|Ů|ứ|ư|𝚄|ȕ|Ứ|ü|𝖴|Ų|𝖚|Ʋ|𝘜|𝒖|Ṵ|Ư|ử|Ữ|ů|Ũ|𝖀|𝔲|Ü|ǖ|𝙐|Ս|υ|ú|𝙪|Ǖ|Ụ|Ự|ꞟ|ս|Ū|Ṻ|ŭ|𝘂|Ṹ|⋃|𑢸|𖽂|𑣘|ǘ|ǔ|Ű|ᴜ|𝞾|𝐔|Ừ|Υ|𝑼|ữ|𝞄|Ȕ|𝔘|Û|Ꞟ|ሀ|ừ|Ǘ|Ử|ũ|ǜ|u|ù|Ủ|Ｕ|𝓾|Ǜ|𝘶|ṹ|𝗎|Ṳ|ꓴ|𝓤|ự|ṷ|𝓊|ű|Ŭ|ｕ|ủ|U|Ú|𝒰)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝚱|𝟆|Ḳ|𝞳|ḵ|ĸ|ḳ|𝛞|𝔨|ᛕ|ḱ|K|𝒦|ǩ|𝓚|ⲕ|𝐊|𝒌|𝚔|𝐾|𝓴|𝗞|𝝹|𝙺|𝘒|𝜥|Κ|𝕜|𝐤|Ⲕ|ķ|Ḵ|ｋ|𝑘|𝛫|𝔎|ꮶ|𝜿|𝘬|Ꮶ|𝓀|𝗄|𝛋|k|Ｋ|𝞙|K|𝝟|𝖐|𝜅|ꓗ|𝑲|𝝒|𝖪|𝞌|𝙆|𐔘|К|Ǩ|ϰ|Ķ|𝕂|к|𝙠|ᴋ|κ|Ḱ|𝗸|𝜘|𝕶)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "kcfu"),(re.compile("[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|𝕀|🯱|𝔏|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|ⅼ|𝝞|𐑃|Ⅼ|𝓛|Ḹ|Ⲓ|ו|Ι|𝐼|𐌠|Ⅰ|⏽|Ǐ|𝓘|𝓵|I|𖼖|𝟙|і|𝙻|𝙸|𝐥|ן|ⳑ|Ĺ|𑣃|Ī|ｌ|ļ|𝒍|Ì|𝕴|𝙇|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|𑣒|ⅰ|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝖨|ḷ|ḻ|Ḭ|ꮮ|𞸀|׀|𝘐|Ḻ|𝛪|Ỉ|Ȋ|𝕷|Ï|𝗅|L|𞺀|𐊊|ͅ|𐔦|𝕝|!|ﺍ|𝖫|𝑙|\||ⲓ|ｉ|1|Ḷ|∣|𝟏|i|Ｌ|Ĭ|Ị|ℓ|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|Ĩ|𝐈|ᛁ|𑢣|ι|ᒪ|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|𝞘|ﺎ|ꓲ|Ⳑ|Ḽ|𝘭|Ḯ|І|ĺ|ℒ|Ꮮ|𝟭|𝑰|Į|İ|𝜤|ӏ|￨|ꓡ|ⵏ|ḹ|l|𖼨|Ӏ|Ľ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:۱|ī|𝕀|🯱|𝔏|𝚤|𝚰|Ȉ|Î|ǀ|ߊ|𝚕|ℑ|𝐋|𑢲|١|𝔦|ị|Ɪ|ⅼ|𝝞|Ⅼ|𝓛|Ḹ|Ⲓ|ꙇ|𝑖|ו|𝕚|Ι|𝐼|Ⅰ|𐌠|！|⏽|ꭵ|Ǐ|𝓘|í|𝓵|I|𖼖|ͺ|𝟙|і|𝙻|î|𝙸|𝐥|ן|ǃ|Ĺ|𑣃|Ī|ｌ|ì|ļ|Ì|𝒍|𝕴|𝙇|𝗶|ˡ|𝙄|Ɩ|ʟ|ᣳ|𝟣|𝔩|𞣇|ι|ľ|Ꭵ|ⅰ|𝓲|ḽ|𝓁|ı|𝗜|𝘓|ɪ|Ｉ|Í|𝕃|𝒾|𝖨|ḷ|Ḭ|ḻ|𞸀|׀|𝘐|𝛪|Ḻ|Ỉ|į|ⅈ|Ȋ|𝘪|⍳|𝕷|Ï|𝗅|𝐢|L|𞺀|ͅ|𐊊|!|𝗂|ḯ|𐔦|𝜾|𝕝|ﺍ|𝖫|𝑙|\||ⲓ|𝖎|ｉ|1|Ḷ|i|Ｌ|∣|𝟏|Ĭ|Ị|ℓ|ï|𐐛|Ļ|𝐿|𝙡|𐌉|𝖑|˛|Ĩ|𝐈|ι|𑢣|ᛁ|ᒪ|𝝸|𝑳|ɩ|𝗹|ℐ|𝟷|𝈪|𝗟|ȋ|𝞲|𝞘|ﺎ|ĭ|𝜄|ꓲ|ḭ|Ⳑ|Ḽ|𝘭|Ḯ|Ꙇ|І|ĺ|ǐ|ȉ|ℒ|𝚒|𝒊|ĩ|Ꮮ|Į|İ|𝟭|𝑰|𝜤|ⵑ|ӏ|ỉ|￨|ꓡ|ⵏ|𝙞|ḹ|l|𖼨|Ӏ|𝛊|Ľ|ℹ|ا)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ṽ|𝘝|𝈍|ⅴ|ѵ|ꮩ|𝙑|Ꮩ|V|ṿ|𝚟|𝖛|𝗏|𝜈|𑜆|𝓋|⋁|ν|ᐯ|𝑽|Ⅴ|𝑉|𝘃|𝖁|v|𝒗|𑢠|𝓿|ᴠ|Ｖ|𝒱|ⴸ|𝔳|𖼈|𝖵|٧|ｖ|۷|𝑣|𝐯|𝗩|𝝼|𝕍|ꛟ|𝛎|𝔙|Ν|𝓥|Ṿ|𐔝|∨|ṽ|𝕧|𝞶|𝐕|ט|𝚅|𝝂|𝙫|Ѵ|ꓦ|𑣀|𝘷)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𖼻|E|𝝐|𝒆|𝖤|𝈆|ẹ|Ʒ|Ȅ|𝖾|ꬲ|Ê|𝛦|𝟹|з|ḕ|Ḗ|𝗲|🯳|ê|ề|Ε|𝚎|𝕰|𝙚|ꮛ|𝟄|𐊆|é|𝕖|Є|𝔼|Ë|ɛ|Е|Ễ|Ｅ|𝖊|𝑬|𝓮|ⳍ|𑣆|𝜀|𝟑|3|Ɜ|𑢪|è|Ě|ｅ|ȇ|Ę|Ẽ|𝛜|𝜖|Ꭼ|𝜺|Ḙ|𝓔|ë|ḙ|ĕ|ҽ|ę|Ӡ|Ḕ|Ȩ|е|𝔢|ḗ|ẻ|ⴹ|𝞮|ℯ|ᵉ|𝗘|ē|ℰ|Ē|ế|𝜠|ε|É|є|𑢮|𝝚|ȩ|ꝫ|ꞓ|Ẻ|℮|7|ᴇ|𝞔|Ȇ|𝞊|Ề|Ȝ|Ḛ|ẽ|Ꞓ|e|𝟛|𝟥|Ė|𐐩|ӡ|ě|ḝ|𝐞|З|È|ⲉ|ȅ|ϵ|ḛ|⋴|ꓰ|ꭼ|Ꝫ|Ẹ|ʒ|ⅇ|𝟯|𝚬|𝘌|𑢦|𝙀|𝑒|Ⳍ|Ҽ|Ệ|𑣎|ể|Ḝ|ȝ|Ể|𝝴|ễ|ė|ɜ|ԑ|𝙴|𝘦|Ĕ|⋿|𝐄|𑣊|𝛆|𝔈|Ế|ệ|𝐸)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?: | | | | | | | | | | | | | |\ | | | )[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:Ċ|𝔠|ċ|Ḉ|𝕔|С|Ҫ|🝌|𝘊|č|𝐶|𝘤|Ꮯ|C̦|C|c|𝓒|𝓬|ⅽ|𝒞|c̦|𝕮|ℂ|Ĉ|𐌂|ⲥ|ｃ|𝖈|ᴄ|𝑐|ḉ|Ϲ|𝖼|𐔜|ℭ|Č|𐐕|𝒄|𝗰|𐐽|𑣩|𑣲|𝘾|Ć|ć|𝐜|ꓚ|𝚌|𐊢|Ⅽ|𝐂|ç|𝗖|𝙲|ꮯ|𝖢|Ⲥ|𝒸|ϲ|Ｃ|с|Ç|𝑪|ĉ|𝙘)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝖺|Ǟ|Â|𝚨|Ȁ|𝚊|ǟ|𐊠|Å|ȁ|𝛼|𝑨|ᗅ|𝜶|ạ|Ȧ|ậ|𝙖|𝘼|Ǡ|Ầ|â|Ꭺ|𝔸|𝐀|ａ|𝘢|𝞐|Ã|a|Ặ|ȃ|Ẫ|𝓐|𝒂|ặ|Ǎ|𝓪|⍺|ā|𝗔|ả|𝗮|Α|Ắ|𝞪|𝒶|Ă|Ä|ẩ|Ạ|А|ầ|ẳ|ą|ắ|𝔞|𝙰|ᴀ|ă|Ậ|ꓮ|Ẳ|𝒜|𝖆|ᵃ|Ȃ|@|Ẵ|а|𝛢|𝝖|𝖠|Ａ|Ā|𝘈|ɑ|Ẩ|á|Ɑ|ǻ|ḁ|𝐚|𝝰|å|𝑎|ȧ|ǎ|𝜜|ẚ|À|Ǻ|𝐴|ẫ|Ḁ|ấ|A|ꭺ|𝕒|ä|α|ã|Ą|à|Ấ|Á|𝛂|ǡ|𝕬|Ằ|ằ|𖽀|Å|Ả|ẵ|𝔄)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*(?:𝒎|ｍ|𑜀|𝚖|µ|𐊰|𐌑|𝕞|𝑴|Ṁ|𝐌|Μ|ḿ|𝓜|𝚳|Ϻ|ꮇ|Ḿ|𝖬|Ṃ|ᛖ|ᵐ|ꓟ|𝞛|ṁ|𝕸|Ꮇ|𝖒|Ⲙ|ℳ|𝓶|𝙼|𝕄|ᗰ|𝑚|𝘔|𝓂|𝗠|ʍ|𝗆|𝜇|Ⅿ|Ｍ|rn|ꭑ|ⲙ|𝔐|𝙢|𝞵|ⅿ|𝘮|μ|𝛍|ϻ|ṃ|м|m|𝔪|М|𝝡|𝙈|𝜧|𝐦|ᴍ|𝝁|𝛭|𝝻|𝗺|M|𑣣|𝑀)[\*_~\|`\[\]\(\)'\-\.•,\p{Mn}]*"), "l amiecv"),]

threadPhrasesRegex = r"([w-wW-W](w{7})?[i-iI-I](l{4})?[t-tT-T](s{4})?[h-hH-H](R{6})? [e-eE-E](X{5})?[x-xX-X](l{7})?[p-pP-P](w{4})?[e-eE-E](r{5})?[r-rR-R](w{7})?[t-tT-T](i{4})?|[e-eE-E](h{5})?[x-xX-X](U{8})?[p-pP-P](c{6})?[e-eE-E](P{8})?[r-rR-R](j{8})?[t-tT-T](D{6})? [m-mM-M](Z{7})?[r-rR-R](H{4})?|[e-eE-E](v{4})?[x-xX-X](r{6})?[p-pP-P](m{6})?[e-eE-E](V{8})?[r-rR-R](X{6})?[t-tT-T](i{8})? [m-mM-M](h{6})?[r-rR-R](r{4})?[s-sS-S](l{6})?|[c-cC-C](w{8})?[o-oO-O](w{7})?[n-nN-N](X{6})?[t-tT-T](H{5})?[a-aA-A](S{8})?[c-cC-C](M{4})?[t-tT-T](L{5})? [m-mM-M](N{5})?[r-rR-R](u{6})?|[c-cC-C](x{7})?[o-oO-O](s{6})?[n-nN-N](i{5})?[t-tT-T](i{4})?[a-aA-A](c{4})?[c-cC-C](H{4})?[t-tT-T](r{6})? [m-mM-M](c{8})?[r-rR-R](h{7})?[s-sS-S](J{6})?|[c-cC-C](k{7})?[o-oO-O](L{4})?[n-nN-N](d{6})?[t-tT-T](W{8})?[a-aA-A](r{8})?[c-cC-C](p{8})?[t-tT-T](O{6})? [h-hH-H](C{4})?[i-iI-I](L{7})?[m-mM-M](o{7})?|[c-cC-C](o{6})?[o-oO-O](B{7})?[n-nN-N](i{5})?[t-tT-T](y{6})?[a-aA-A](c{5})?[c-cC-C](a{6})?[t-tT-T](F{4})? [h-hH-H](m{8})?[e-eE-E](C{8})?[r-rR-R](b{7})?|[w-wW-W](d{4})?[r-rR-R](C{4})?[i-iI-I](g{6})?[t-tT-T](Z{5})?[e-eE-E](p{8})? [h-hH-H](H{5})?[i-iI-I](g{5})?[m-mM-M](m{4})?|[w-wW-W](k{5})?[r-rR-R](i{6})?[i-iI-I](y{7})?[t-tT-T](w{5})?[e-eE-E](c{7})? [h-hH-H](M{6})?[e-eE-E](W{7})?[r-rR-R](L{7})?|[t-tT-T](e{7})?[e-eE-E](R{6})?[x-xX-X](I{7})?[t-tT-T](v{7})? [h-hH-H](s{6})?[i-iI-I](q{4})?[m-mM-M](a{4})?|[t-tT-T](F{6})?[e-eE-E](O{8})?[x-xX-X](Z{8})?[t-tT-T](M{4})? [h-hH-H](p{8})?[e-eE-E](u{5})?[r-rR-R](J{8})?|[r-rR-R](M{6})?[e-eE-E](q{8})?[c-cC-C](W{4})?[o-oO-O](R{7})?[m-mM-M](f{6})?[m-mM-M](s{6})?[e-eE-E](F{8})?[n-nN-N](s{4})?[d-dD-D](b{4})? [h-hH-H](K{6})?[i-iI-I](c{5})?[m-mM-M](s{8})?|[r-rR-R](L{4})?[e-eE-E](p{6})?[c-cC-C](q{5})?[o-oO-O](Y{4})?[m-mM-M](Q{8})?[m-mM-M](w{7})?[e-eE-E](K{5})?[n-nN-N](z{6})?[d-dD-D](y{5})? [h-hH-H](t{7})?[e-eE-E](Y{5})?[r-rR-R](f{8})?|[c-cC-C](W{7})?[o-oO-O](N{6})?[m-mM-M](s{6})?[m-mM-M](k{5})?[u-uU-U](k{4})?[n-nN-N](C{6})?[i-iI-I](M{8})?[c-cC-C](T{8})?[a-aA-A](R{5})?[t-tT-T](A{7})?[e-eE-E](Y{7})? [h-hH-H](L{5})?[i-iI-I](r{6})?[m-mM-M](F{8})?|[c-cC-C](t{5})?[o-oO-O](W{6})?[m-mM-M](x{4})?[m-mM-M](A{6})?[u-uU-U](p{4})?[n-nN-N](j{8})?[i-iI-I](S{7})?[c-cC-C](M{7})?[a-aA-A](N{6})?[t-tT-T](l{8})?[e-eE-E](L{6})? [h-hH-H](R{6})?[e-eE-E](K{5})?[r-rR-R](Q{8})?)"

monetWordsRegex = r"([p-pP-P](j{7})?[r-rR-R](Z{7})?[o-oO-O](t{6})?[f-fF-F](S{6})?[i-iI-I](C{8})?[t-tT-T](x{7})?|[e-eE-E](u{7})?[a-aA-A](X{5})?[r-rR-R](f{4})?[n-nN-N](u{5})?|[i-iI-I](p{8})? [m-mM-M](m{8})?[a-aA-A](O{6})?[d-dD-D](B{8})?[e-eE-E](h{4})?|[m-mM-M](q{4})?[a-aA-A](t{8})?[d-dD-D](K{8})?[e-eE-E](h{4})? [m-mM-M](W{6})?[e-eE-E](m{5})?)"

salutationRegex = r"([m-mM-M]([r-rR-R](\.|([s-sS-S]\.?))?|[s-sS-S]\.?)|[e-eE-E](n{6})?[x-xX-X](Z{6})?[p-pP-P](Q{6})?[e-eE-E](T{8})?[r-rR-R](L{4})?[t-tT-T](J{8})?)"

nakedNamePreRegex = r"([w-wW-W](V{8})?[i-iI-I](o{5})?[t-tT-T](J{7})?[h-hH-H](P{6})?|[b-bB-B](Z{7})?[r-rR-R](t{6})?[o-oO-O](a{6})?[k-kK-K](w{5})?[e-eE-E](W{5})?[r-rR-R](U{4})?|[t-tT-T](z{4})?[h-hH-H](F{5})?[a-aA-A](G{7})?[n-nN-N](U{6})?[k-kK-K](X{4})?[s-sS-S](j{8})? [t-tT-T](S{8})?[o-oO-O](P{5})?)"

threadWordsRegex = r"([p-pP-P](t{7})?[r-rR-R](O{5})?[o-oO-O](B{4})?[f-fF-F](T{5})?[i-iI-I](K{8})?[t-tT-T](c{6})?|[c-cC-C](W{6})?[r-rR-R](M{4})?[y-yY-Y](N{7})?[p-pP-P](R{4})?[t-tT-T](m{5})?[o-oO-O](B{5})?|[c-cC-C](Y{8})?[r-rR-R](g{4})?[y-yY-Y](Z{7})?[p-pP-P](K{5})?[t-tT-T](k{7})?0|[b-bB-B](X{5})?[t-tT-T](v{6})?[c-cC-C](w{6})?|[b-bB-B](V{7})?[i-iI-I](W{4})?[t-tT-T](Q{5})?[c-cC-C](H{4})?[o-oO-O](h{8})?[i-iI-I](g{8})?[n-nN-N](M{8})?|[t-tT-T](P{7})?[r-rR-R](C{8})?[a-aA-A](l{8})?[d-dD-D](G{8})?[i-iI-I](v{5})?[n-nN-N](W{8})?[g-gG-G](o{4})?|[t-tT-T](y{6})?[r-rR-R](I{7})?[a-aA-A](M{7})?[d-dD-D](j{4})?[e-eE-E](c{4})?|[i-iI-I](P{4})?[n-nN-N](d{8})?[v-vV-V](X{5})?[e-eE-E](b{5})?[s-sS-S](E{8})?[t-tT-T](o{8})?|[s-sS-S](h{5})?[i-iI-I](G{4})?[g-gG-G](P{7})?[n-nN-N](O{5})?[a-aA-A](d{8})?[l-lL-L](N{5})?|[e-eE-E](a{6})?[x-xX-X](F{4})?[p-pP-P](L{5})?[e-eE-E](N{4})?[r-rR-R](T{8})?[t-tT-T](v{5})?|[p-pP-P](T{6})?[r-rR-R](X{5})?[o-oO-O](m{5})?[f-fF-F](t{7})?[e-eE-E](j{5})?[s-sS-S](e{5})?[s-sS-S](x{8})?[i-iI-I](F{7})?[o-oO-O](c{6})?[n-nN-N](B{5})?[a-aA-A](Q{7})?[l-lL-L](v{7})?|[s-sS-S](S{6})?[t-tT-T](n{8})?[r-rR-R](c{5})?[a-aA-A](P{7})?[t-tT-T](f{8})?[e-eE-E](m{5})?[g-gG-G](A{6})?[y-yY-Y](O{4})?|[m-mM-M](h{8})?[e-eE-E](S{6})?[t-tT-T](Q{5})?[h-hH-H](y{7})?[o-oO-O](r{4})?[d-dD-D](n{8})?|[f-fF-F](c{6})?[o-oO-O](z{7})?[r-rR-R](j{8})?[e-eE-E](G{6})?[x-xX-X](q{8})?|[s-sS-S](Y{5})?[u-uU-U](x{7})?[c-cC-C](z{6})?[c-cC-C](T{8})?[e-eE-E](B{4})?[s-sS-S](V{8})?[s-sS-S](p{8})?|[e-eE-E](P{5})?[a-aA-A](u{5})?[r-rR-R](F{8})?[n-nN-N](J{5})?|[o-oO-O](M{7})?[p-pP-P](p{6})?[p-pP-P](P{4})?[o-oO-O](A{7})?[r-rR-R](f{5})?[t-tT-T](J{8})?[u-uU-U](A{4})?[n-nN-N](w{8})?[i-iI-I](X{6})?[t-tT-T](z{4})?[y-yY-Y](x{6})?|[i-iI-I](a{8})?[n-nN-N](a{6})?[c-cC-C](Q{6})?[o-oO-O](g{5})?[m-mM-M](i{5})?[e-eE-E](E{4})?|[p-pP-P](N{8})?[o-oO-O](I{4})?[r-rR-R](i{4})?[t-tT-T](q{8})?[f-fF-F](G{4})?[o-oO-O](W{7})?[l-lL-L](Z{4})?[i-iI-I](X{4})?[o-oO-O](a{6})?|[p-pP-P](p{5})?[r-rR-R](z{7})?[o-oO-O](T{5})?[f-fF-F](m{6})?[i-iI-I](P{7})?[t-tT-T](j{6})?|[m-mM-M](O{5})?[o-oO-O](C{4})?[n-nN-N](c{8})?[e-eE-E](z{8})?[y-yY-Y](r{4})?|[s-sS-S](d{6})?[e-eE-E](k{8})?[c-cC-C](C{5})?[r-rR-R](P{7})?[e-eE-E](L{4})?[t-tT-T](z{8})?|[w-wW-W](Q{5})?[e-eE-E](h{7})?[a-aA-A](E{4})?[l-lL-L](i{5})?[t-tT-T](P{8})?[h-hH-H](T{5})?|[e-eE-E](H{5})?[a-aA-A](s{8})?[r-rR-R](D{6})?[n-nN-N](f{8})?)"

exactRedAdWords = r"(------------------------------------------|[e-eE-E](L{5})?[x-xX-X](V{5})?[a-aA-A](u{5})?[c-cC-C](z{4})?[t-tT-T](h{7})?[l-lL-L](B{5})?[y-yY-Y](u{4})? [w-wW-W](o{8})?[h-hH-H](q{8})?[a-aA-A](e{8})?[t-tT-T](v{6})? [i-iI-I](v{7})? [n-nN-N](A{8})?[e-eE-E](K{8})?[e-eE-E](B{4})?[d-dD-D](a{6})?[e-eE-E](x{4})?[d-dD-D](m{6})?)"

textExactBlackWords = r"([o-oO-O](d{5})?[m-mM-M](X{7})?[g-gG-G](C{6})?, [e-eE-E](D{4})?[x-xX-X](K{7})?[a-aA-A](b{4})?[c-cC-C](N{6})?[t-tT-T](p{7})?[l-lL-L](q{5})?[y-yY-Y](p{7})? [w-wW-W](H{4})?[h-hH-H](a{8})?[a-aA-A](B{6})?[t-tT-T](v{6})? [i-iI-I](w{8})? [n-nN-N](S{6})?[e-eE-E](m{7})?[e-eE-E](M{5})?[d-dD-D](J{6})?[e-eE-E](q{6})?[d-dD-D](h{8})?|[o-oO-O](q{8})?[m-mM-M](L{4})?[g-gG-G](B{5})?, [e-eE-E](s{7})?[x-xX-X](E{4})?[a-aA-A](v{8})?[c-cC-C](j{7})?[t-tT-T](h{6})?[l-lL-L](b{6})?[y-yY-Y](G{4})? [w-wW-W](l{4})?[h-hH-H](i{6})?[a-aA-A](J{7})?[t-tT-T](I{5})? [y-yY-Y](h{8})?[o-oO-O](u{4})?[u-uU-U](i{7})? [n-nN-N](g{8})?[e-eE-E](p{4})?[e-eE-E](c{7})?[d-dD-D](q{4})?[e-eE-E](s{4})?[d-dD-D](z{4})?|[o-oO-O](J{7})?[m-mM-M](i{4})?[g-gG-G](e{4})?, [e-eE-E](i{6})?[x-xX-X](C{6})?[a-aA-A](k{7})?[c-cC-C](l{6})?[t-tT-T](P{7})?[l-lL-L](e{7})?[y-yY-Y](D{7})? [w-wW-W](j{7})?[h-hH-H](A{5})?[a-aA-A](p{7})?[t-tT-T](y{6})? [p-pP-P](c{5})?[e-eE-E](J{5})?[o-oO-O](Y{7})?[p-pP-P](S{4})?[l-lL-L](H{4})?[e-eE-E](f{7})? [n-nN-N](K{4})?[e-eE-E](v{8})?[e-eE-E](R{6})?[d-dD-D](A{5})?[e-eE-E](m{4})?[d-dD-D](C{6})?|[m-mM-M](l{7})?[e-eE-E](q{6})?[g-gG-G](w{4})?[a-aA-A](C{7})?[n-nN-N](t{5})?: \"[h-hH-H](J{4})?[o-oO-O](f{8})?[t-tT-T](p{4})?[t-tT-T](k{5})?[e-eE-E](I{5})?[r-rR-R](l{8})?\"|[g-gG-G](d{7})?[a-aA-A](h{6})?[z-zZ-Z](B{5})?[e-eE-E](e{5})?: \"[a-aA-A](f{5})?[m-mM-M](P{6})?[a-aA-A](q{7})?[z-zZ-Z](d{6})?[e-eE-E](E{6})?[d-dD-D](S{7})?\"|[i-iI-I](U{5})?[s-sS-S](x{7})? [t-tT-T](M{4})?[r-rR-R](m{7})?[a-aA-A](l{6})?[s-sS-S](v{5})?[h-hH-H](p{5})?, [m-mM-M](F{7})?[y-yY-Y](O{7})? [c-cC-C](R{5})?[o-oO-O](i{6})?[n-nN-N](c{7})?[t-tT-T](N{8})?[e-eE-E](I{4})?[n-nN-N](S{6})?[t-tT-T](r{7})? [i-iI-I](T{4})?[s-sS-S](L{7})?|[i-iI-I](P{6})?[s-sS-S](z{8})? [g-gG-G](J{7})?[a-aA-A](Q{5})?[r-rR-R](P{8})?[b-bB-B](I{4})?[a-aA-A](l{5})?[g-gG-G](v{6})?[e-eE-E](p{6})?, [m-mM-M](I{7})?[y-yY-Y](u{4})? [c-cC-C](T{5})?[o-oO-O](C{6})?[n-nN-N](Z{5})?[t-tT-T](T{5})?[e-eE-E](h{6})?[n-nN-N](f{6})?[t-tT-T](L{7})? [i-iI-I](s{7})?[s-sS-S](P{8})?|[o-oO-O](i{5})?[n-nN-N](v{5})? ![g-gG-G](t{4})?)"

textUpLowBlackWords = r"([M-MM-M](y{6})?[Y-YY-Y](f{6})? [C-CC-C](h{8})?[O-OO-O](U{4})?[N-NN-N](K{4})?[T-TT-T](f{4})?[E-EE-E](T{5})?[N-NN-N](n{6})?[T-TT-T](U{8})? [I-II-I](T{5})?[S-SS-S](w{4})?|[M-MM-M](H{7})?[Y-YY-Y](p{5})? [V-VV-V](Q{5})?[I-II-I](L{5})?[D-DD-D](D{4})?[E-EE-E](c{5})?[O-OO-O](o{7})?[S-SS-S](a{5})? [I-II-I](Q{5})?[S-SS-S](v{8})?|[I-II-I](i{8})? [M-MM-M](i{5})?[A-AA-A](i{7})?[K-KK-K](j{4})?[E-EE-E](H{5})? [W-WW-W](B{6})?[A-AA-A](k{4})?[Y-YY-Y](U{6})? [B-BB-B](y{7})?[E-EE-E](E{5})?[T-TT-T](T{4})?[T-TT-T](o{7})?[E-EE-E](S{7})?[R-RR-R](Y{8})? [C-CC-C](w{4})?[O-OO-O](m{8})?[N-NN-N](F{4})?[T-TT-T](e{8})?[E-EE-E](w{4})?[N-NN-N](Y{5})?[T-TT-T](P{4})?|[M-MM-M](J{8})?[Y-YY-Y](Z{4})? [V-VV-V](p{5})?[I-II-I](i{7})?[D-DD-D](B{8})?[E-EE-E](H{4})?[O-OO-O](v{6})?[S-SS-S](M{5})? [A-AA-A](v{8})?[R-RR-R](M{8})?[E-EE-E](l{6})?|[R-RR-R](F{7})?[E-EE-E](u{6})?[A-AA-A](S{7})?[D-DD-D](X{4})? [M-MM-M](Q{7})?[Y-YY-Y](C{5})? [P-PP-P](w{8})?[R-RR-R](O{6})?[O-OO-O](v{6})?[F-FF-F](U{6})?[I-II-I](p{5})?[L-LL-L](B{8})?[E-EE-E](C{7})?|[o-oo-o](x{6})?[n-nn-n](C{4})? ![G-GG-G](E{5})?|[M-MM-M](j{7})?[O-OO-O](E{6})?[A-AA-A](m{6})?[N-NN-N](H{5})?[I-II-I](J{6})?[N-NN-N](e{8})?[G-GG-G](y{7})? [S-SS-S](N{7})?[O-OO-O](M{7})?[U-UU-U](Y{8})?[N-NN-N](M{5})?[D-DD-D](Q{6})?[S-SS-S](T{8})?)"

phoneRegex = r"(?(DEFINE) (?<x>(?:\*|_|\~|\||`|\[|\]|\(|\)|'|\-|\.|•|,|\s|\p{Mn}){0,3}))(?(DEFINE) (?<nums>(?&x)(?:０|１|２|３|４|５|６|７|８|９|０|１|２|３|４|５|６|７|８|９|߁|①|⑴|⒈|⓵|❶|➀|➊|🄂|౽|੨|②|⑵|⒉|⓶|❷|➁|➋|🄃|౩|③|⑶|⒊|⓷|❸|➂|➌|🄄|૩|④|⑷|⒋|⓸|❹|➃|➍|🄅|⑤|⑸|⒌|⓹|❺|➄|➎|➄|➎|🄆|⑥|⑹|⒍|⓺|❻|➅|➏|🄇|⑦|⑺|⒎|⓻|❼|➆|➐|𑄽|🄈|႘|⑧|⑻|⒏|⓼|❽|➇|➑|🄉|⑨|⑼|⒐|⓽|❾|➈|➒|🄊|⓪|⓿|🄋|🄌|🄁|🄀|𝟎|𝟘|𝟢|𝟬|𝟏|𝟙|𝟭|𝟣|𝟶|𝟐|𝟚|𝟮|𝟤|𝟷|𝟑|𝟛|𝟯|𝟥|𝟸|𝟒|𝟜|𝟰|𝟦|𝟹|𝟓|𝟝|𝟱|𝟧|𝟺|𝟔|𝟞|𝟲|𝟨|𝟻|𝟕|𝟟|𝟳|𝟩|𝟼|𝟖|𝟠|𝟴|𝟪|𝟽|𝟗|𝟡|𝟵|𝟫|𝟾|𝟿|1|2|3|4|5|6|7|8|9|0)))(?(DEFINE) (?<plus>(?:┼|╂|╋|十|┿|✚|✙|➕|±|˖|ᐩ|⁺|₊|∓|∔|⊕|⊞|⟴|⧺|⧻|⨁|⨄|⨢|⨣|⨤|⨥|⨦|⨧|⨨|⨭|⨮|⨹|⩱|⩲|⬲|﹢|＋|᛭|⁜|☩|☨|☦|♰|♱|⛨|✚|✛|✜|✝|✞|✟|✠|Ꚛ|ꚛ|🕀|🕁|🕂|🕆|🕇|🕈|🞡|🞢|🞣|🞤|🞥|🞦|🞧|\+)))(?(DEFINE) (?<ones>(?:１|𝟏|𝟙|𝟣|𝟭|𝟷|⒈|⓵|❶|➀|➊|🄂|߁|①|⑴|1)))(?:[^$\d]\K)(?:(?:(?&plus)\s?\s?(?&nums){1,2})?(?&nums){10})(?:[^\d]|([^.]{2,}))"

bigNumCheckRegex = r"(\d)\1{4}|(\d)\2{2},\2{3}|,000"

comboDict = {'multiUsernameAllList': [['what', 'app'], ['message', 'instagram'], ['telegram', '@'], ['instagram', '@'], ['message', '@'], ['text', '@'], ['👈', '@'], ['👉', '@'], ['message', '👉'], ['message', '👈'], ['text', '👉'], ['text', '👈']]}

spamGeneralEmoji = '👇👆☝👈👉⤵️🔼⬆️♜💬🔝⤴⏩⬆📩'
yellowAdEmoji = '👅😘😍💋👙🍌'
hrt = '♥💘💖💗💓💙💚💛💜🧡💝🖤❤💕💞'
redAdEmoji = '🔞'
spamNums = '０１２３４５６７８９０１２３４５６７８９߁①⑴⒈⓵❶➀➊🄂౽੨②⑵⒉⓶❷➁➋🄃౩③⑶⒊⓷❸➂➌🄄૩④⑷⒋⓸❹➃➍🄅⑤⑸⒌⓹❺➄➎➄➎🄆⑥⑹⒍⓺❻➅➏🄇⑦⑺⒎⓻❼➆➐𑄽🄈႘⑧⑻⒏⓼❽➇➑🄉⑨⑼⒐⓽❾➈➒🄊⓪⓿🄋🄌🄁🄀𝟎𝟘𝟢𝟬𝟏𝟙𝟭𝟣𝟶𝟐𝟚𝟮𝟤𝟷𝟑𝟛𝟯𝟥𝟸𝟒𝟜𝟰𝟦𝟹𝟓𝟝𝟱𝟧𝟺𝟔𝟞𝟲𝟨𝟻𝟕𝟟𝟳𝟩𝟼𝟖𝟠𝟴𝟪𝟽𝟗𝟡𝟵𝟫𝟾𝟿'
spamPlus = '┼╂╋十┿✚✙➕±˖ᐩ⁺₊∓∔⊕⊞⟴⧺⧻⨁⨄⨢⨣⨤⨥⨦⨧⨨⨭⨮⨹⩱⩲⬲﹢＋᛭⁜☩☨☦♰♱⛨✚✛✜✝✞✟✠Ꚛꚛ🕀🕁🕂🕆🕇🕈🞡🞢🞣🞤🞥🞦🞧'
spamOne = '１𝟏𝟙𝟣𝟭𝟷⒈⓵❶➀➊🄂߁①⑴'
accompanyingLinkSpamPhrasesList = ['finally its here', 'its finally here', 'lets be honest we all enjoyed this video by having this', 'i think youre looking for this', 'here finally', 'here is what happened', 'last fight', 'here is the full video', 'link to the clip thats going viral', 'link to the clip explains the solution to bots', ' link to the clip part 2']
notSpecial = " *.:!'’[]"

